"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ip = void 0;
const common_1 = require("./utility/common");
const ipAddrOnly = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/m;
const ipAddrContains = /(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)/gm;
function isValid(addr) {
    return common_1.common.isValid(addr, ipAddrOnly);
}
function retrieve(str) {
    return common_1.common.retrieve(str, ipAddrContains);
}
function expression(global) {
    if (global) {
        return new RegExp(ipAddrOnly, 'g');
    }
    return ipAddrOnly;
}
function remove(str) {
    return common_1.common.remove(str, ipAddrContains);
}
function swap(str, newStr) {
    return common_1.common.swap(str, newStr, ipAddrContains);
}
const ip = {
    expression,
    isValid,
    remove,
    retrieve,
    swap
};
exports.ip = ip;
