"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.common = void 0;
function isValid(str, exp) {
    if (typeof str !== 'string') {
        return false;
    }
    return exp.test(str);
}
function swap(str, str2, exp) {
    if (str && str2 && exp) {
        return str.replace(exp, str2);
    }
    else {
        return '';
    }
}
function remove(str, exp) {
    if (typeof str !== 'string') {
        return str;
    }
    return str.replace(exp, '').trim();
}
function retrieve(str, exp) {
    if (typeof str !== 'string') {
        return [];
    }
    return str.match(exp) || [];
}
const common = {
    isValid,
    remove,
    retrieve,
    swap
};
exports.common = common;
